import type { DId } from '../../utils';
import React from 'react';
export interface DAccordionItem<ID extends DId> {
    id: ID;
    title: React.ReactNode;
    region: React.ReactNode;
    arrow?: boolean | 'left';
    disabled?: boolean;
}
export interface DAccordionProps<ID extends DId, T extends DAccordionItem<ID>> extends Omit<React.HTMLAttributes<HTMLDivElement>, 'children'> {
    dList: T[];
    dActive?: ID | null | ID[];
    dActiveOne?: boolean;
    dArrow?: 'left' | 'right' | false;
    onActiveChange?: (id: any, item: any) => void;
    afterActiveChange?: (id: any, item: any, active: boolean) => void;
}
export declare function DAccordion<ID extends DId, T extends DAccordionItem<ID>>(props: DAccordionProps<ID, T>): JSX.Element | null;
