import type { DNestedChildren } from '../../utils';
import React from 'react';
export interface DAutoCompleteRef {
    updatePosition: () => void;
}
export interface DAutoCompleteItem {
    value: string;
    disabled?: boolean;
}
export interface DAutoCompleteProps<T extends DAutoCompleteItem> extends React.HTMLAttributes<HTMLDivElement> {
    dList: DNestedChildren<T>[];
    dVisible?: boolean;
    dLoading?: boolean;
    dCustomItem?: (item: DNestedChildren<T>) => React.ReactNode;
    onVisibleChange?: (visible: boolean) => void;
    afterVisibleChange?: (visible: boolean) => void;
    onItemClick?: (value: string, item: T) => void;
    onScrollBottom?: () => void;
}
declare function AutoComplete<T extends DAutoCompleteItem>(props: DAutoCompleteProps<T>, ref: React.ForwardedRef<DAutoCompleteRef>): JSX.Element | null;
export declare const DAutoComplete: <T extends DAutoCompleteItem>(props: DAutoCompleteProps<T> & React.RefAttributes<DAutoCompleteRef>) => ReturnType<typeof AutoComplete>;
export {};
