var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { useEffect, useRef, useState } from 'react';
import { useAsync, useElement, useEventCallback, useIsomorphicLayoutEffect } from '@react-devui/hooks';
import { VerticalAlignTopOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName, scrollTo } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useLayout } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DTransition } from '../_transition';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DBackTop' });
export function DBackTop(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dPage, dDistance = 400, dScrollBehavior = 'instant' } = _a, restProps = __rest(_a, ["children", "dPage", "dDistance", "dScrollBehavior"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { dScrollEl, dResizeEl } = useLayout();
    //#endregion
    const dataRef = useRef({});
    const asyncCapture = useAsync();
    const pageEl = useElement(dPage !== null && dPage !== void 0 ? dPage : dScrollEl);
    const resizeEl = useElement(dResizeEl);
    const [visible, setVisible] = useState(false);
    const transitionStyles = {
        enter: { opacity: 0 },
        entering: {
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaving: {
            opacity: 0,
            transition: ['opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms linear`).join(', '),
        },
        leaved: { display: 'none' },
    };
    const updateBackTop = useEventCallback(() => {
        if (!pageEl) {
            return;
        }
        setVisible(pageEl.scrollTop >= dDistance);
    });
    useIsomorphicLayoutEffect(() => {
        updateBackTop();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    useEffect(() => {
        if (pageEl) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.fromEvent(pageEl, 'scroll', { passive: true }).subscribe({
                next: () => {
                    updateBackTop();
                },
            });
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, pageEl, updateBackTop]);
    useEffect(() => {
        if (resizeEl) {
            const [asyncGroup, asyncId] = asyncCapture.createGroup();
            asyncGroup.onResize(resizeEl, () => {
                updateBackTop();
            });
            return () => {
                asyncCapture.deleteGroup(asyncId);
            };
        }
    }, [asyncCapture, resizeEl, updateBackTop]);
    return (_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE }, { children: (state) => (_jsx("button", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}back-top`), style: Object.assign(Object.assign({}, restProps.style), transitionStyles[state]), onClick: (e) => {
                var _a, _b, _c;
                (_a = restProps.onClick) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                if (pageEl) {
                    (_c = (_b = dataRef.current).clearTid) === null || _c === void 0 ? void 0 : _c.call(_b);
                    dataRef.current.clearTid = scrollTo(pageEl, {
                        top: 0,
                        behavior: dScrollBehavior,
                    });
                }
            } }, { children: checkNodeExist(children) ? children : _jsx(VerticalAlignTopOutlined, { dSize: 24 }) }))) })));
}
//# sourceMappingURL=BackTop.js.map