import type { DId } from '../../utils';
import React from 'react';
export interface DBreadcrumbItem<ID extends DId> {
    id: ID;
    title: React.ReactNode;
    link?: boolean;
    separator?: React.ReactNode;
}
export interface DBreadcrumbProps<ID extends DId, T extends DBreadcrumbItem<ID>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dList: T[];
    dSeparator?: React.ReactNode;
    onItemClick?: (id: ID, item: T) => void;
}
export declare function DBreadcrumb<ID extends DId, T extends DBreadcrumbItem<ID>>(props: DBreadcrumbProps<ID, T>): JSX.Element | null;
