/// <reference types="react" />
import type { DId } from '../../utils';
import type { DComboboxKeyboardSupportKey } from '../_keyboard-support';
import type { AbstractTreeNode } from '../tree/node';
import type { DCascaderItem } from './Cascader';
import type { Subject } from 'rxjs';
export interface DListProps<V extends DId, T extends DCascaderItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dGetItemId: (value: V) => string;
    dList: AbstractTreeNode<V, T>[];
    dFocusItem: AbstractTreeNode<V, T> | undefined;
    dCustomItem?: (item: T) => React.ReactNode;
    dMultiple: boolean;
    dFocusVisible: boolean;
    dRoot: boolean;
    onFocusChange: (node: AbstractTreeNode<V, T>) => void;
    onClickItem: (node: AbstractTreeNode<V, T>) => void;
    onKeyDown$: Subject<DComboboxKeyboardSupportKey | 'click'>;
}
export declare function DList<V extends DId, T extends DCascaderItem<V>>(props: DListProps<V, T>): JSX.Element | null;
