var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import React, { useMemo, useRef } from 'react';
import { useForkRef } from '@react-devui/hooks';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useGeneralContext } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DComposeItem } from './ComposeItem';
export const DComposeContext = React.createContext(null);
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DCompose' });
function Compose(props, ref) {
    var _a;
    const _b = useComponentConfig(COMPONENT_NAME, props), { children, dSize, dVertical = false, dDisabled = false } = _b, restProps = __rest(_b, ["children", "dSize", "dVertical", "dDisabled"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    const { gSize, gDisabled } = useGeneralContext();
    //#endregion
    //#region Ref
    const elRef = useRef(null);
    //#endregion
    const combineElRef = useForkRef(elRef, ref);
    const size = dSize !== null && dSize !== void 0 ? dSize : gSize;
    const disabled = dDisabled || gDisabled;
    const contextValue = useMemo(() => ({
        gSize: size,
        gDisabled: disabled,
    }), [disabled, size]);
    return (_jsx(DComposeContext.Provider, Object.assign({ value: contextValue }, { children: _jsx("div", Object.assign({}, restProps, { ref: combineElRef, className: getClassName(restProps.className, `${dPrefix}compose`, {
                [`${dPrefix}compose--vertical`]: dVertical,
            }), role: (_a = restProps.role) !== null && _a !== void 0 ? _a : 'group' }, { children: children })) })));
}
export const DCompose = React.forwardRef(Compose);
DCompose.Item = DComposeItem;
//# sourceMappingURL=Compose.js.map