var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { useEffect, useRef, useState } from 'react';
import { useEventCallback } from '@react-devui/hooks';
import { RightOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName, getHorizontalSidePosition, getOriginalSize } from '@react-devui/utils';
import { usePrefixConfig, useTranslation, useMaxIndex } from '../../hooks';
import { TTANSITION_DURING_POPUP } from '../../utils';
import { DPopup } from '../_popup';
import { DTransition } from '../_transition';
export function DSub(props) {
    const { children, dId, dFocusVisible, dPopup, dPopupVisible, dPopupState, dEmpty, dTrigger, dIcon, dLevel = 0, dDisabled, onVisibleChange, updatePosition$, } = props;
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const ulRef = useRef(null);
    const liRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const [popupPositionStyle, setPopupPositionStyle] = useState({
        top: -9999,
        left: -9999,
    });
    const [transformOrigin, setTransformOrigin] = useState();
    const updatePosition = useEventCallback(() => {
        if (ulRef.current && liRef.current) {
            const { width, height } = getOriginalSize(ulRef.current);
            const { top, left, transformOrigin } = getHorizontalSidePosition(liRef.current, { width, height }, 'right', 10);
            setPopupPositionStyle({
                top,
                left,
            });
            setTransformOrigin(transformOrigin);
        }
    });
    const maxZIndex = useMaxIndex(dPopupVisible);
    useEffect(() => {
        if (dPopupVisible) {
            const ob = updatePosition$.subscribe({
                next: () => {
                    updatePosition();
                },
            });
            return () => {
                ob.unsubscribe();
            };
        }
    }, [dPopupVisible, updatePosition, updatePosition$]);
    return (_jsx(DTransition, Object.assign({ dIn: dPopupVisible, dDuring: TTANSITION_DURING_POPUP, onEnterRendered: updatePosition }, { children: (state) => {
            let transitionStyle = {};
            switch (state) {
                case 'enter':
                    transitionStyle = { transform: 'scale(0)', opacity: 0 };
                    break;
                case 'entering':
                    transitionStyle = {
                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-out`).join(', '),
                        transformOrigin,
                    };
                    break;
                case 'leaving':
                    transitionStyle = {
                        transform: 'scale(0)',
                        opacity: 0,
                        transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_POPUP}ms ease-in`).join(', '),
                        transformOrigin,
                    };
                    break;
                case 'leaved':
                    transitionStyle = { display: 'none' };
                    break;
                default:
                    break;
            }
            return (_jsx(DPopup, Object.assign({ dPopup: (_a) => {
                    var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
                    return (_jsx("ul", Object.assign({}, restPProps, { ref: ulRef, className: `${dPrefix}dropdown__sub-popup`, style: Object.assign(Object.assign(Object.assign({}, popupPositionStyle), transitionStyle), { zIndex: maxZIndex }), role: "menu", "aria-labelledby": dId, onClick: pOnClick, onMouseEnter: pOnMouseEnter, onMouseLeave: pOnMouseLeave }, { children: dEmpty ? (_jsx("div", Object.assign({ className: `${dPrefix}dropdown__empty`, style: { paddingLeft: 12 + dLevel * 16 } }, { children: t('No Data') }))) : (dPopup) })));
                }, dVisible: dPopupState, dDisabled: dDisabled, dTrigger: dTrigger, dUpdatePosition: updatePosition, onVisibleChange: onVisibleChange }, { children: (_a) => {
                    var { pOnClick, pOnMouseEnter, pOnMouseLeave } = _a, restPProps = __rest(_a, ["pOnClick", "pOnMouseEnter", "pOnMouseLeave"]);
                    return (_jsxs("li", Object.assign({}, restPProps, { ref: liRef, id: dId, className: getClassName(`${dPrefix}dropdown__item`, `${dPrefix}dropdown__item--sub`, {
                            'is-expand': dPopupVisible,
                            'is-disabled': dDisabled,
                        }), style: { paddingLeft: 12 + dLevel * 16 }, role: "menuitem", "aria-haspopup": true, "aria-expanded": dPopupVisible, "aria-disabled": dDisabled, onClick: pOnClick, onMouseEnter: pOnMouseEnter, onMouseLeave: pOnMouseLeave }, { children: [dFocusVisible && _jsx("div", { className: `${dPrefix}focus-outline` }), checkNodeExist(dIcon) && _jsx("div", Object.assign({ className: `${dPrefix}dropdown__item-icon` }, { children: dIcon })), _jsx("div", Object.assign({ className: `${dPrefix}dropdown__item-content` }, { children: children })), _jsx(RightOutlined, { className: `${dPrefix}dropdown__sub-arrow`, dSize: 14 })] })));
                } })));
        } })));
}
//# sourceMappingURL=Sub.js.map