var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx } from "react/jsx-runtime";
import { isArray, isNumber } from 'lodash';
import React, { useMemo } from 'react';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { useMediaMatch } from './hooks';
export const DRowContext = React.createContext(null);
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DRow' });
export function DRow(props) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dGutter = 0, dResponsiveGutter } = _a, restProps = __rest(_a, ["children", "dGutter", "dResponsiveGutter"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    const mediaMatch = useMediaMatch();
    const gap = (() => {
        const getGap = (gutter) => {
            if (isArray(gutter)) {
                return [gutter[0], gutter[1]];
            }
            return [gutter, gutter];
        };
        let gap = getGap(dGutter);
        if (dResponsiveGutter) {
            for (const breakpoint of mediaMatch) {
                if (breakpoint in dResponsiveGutter) {
                    gap = getGap(dResponsiveGutter[breakpoint]);
                    break;
                }
            }
        }
        return gap;
    })();
    const space = isNumber(gap[1]) ? gap[1] / 2 : `calc(${gap[1]} / 2)`;
    const contextValue = useMemo(() => ({
        gMediaMatch: mediaMatch,
        gSpace: space,
    }), [mediaMatch, space]);
    return (_jsx(DRowContext.Provider, Object.assign({ value: contextValue }, { children: _jsx("div", Object.assign({}, restProps, { className: getClassName(restProps.className, `${dPrefix}row`), style: Object.assign(Object.assign({}, restProps.style), { rowGap: gap[0], marginLeft: isNumber(space) ? -space : `calc(${space} * -1)`, marginRight: isNumber(space) ? -space : `calc(${space} * -1)` }) }, { children: children })) })));
}
//# sourceMappingURL=Row.js.map