var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import { useEffect, useRef, useState } from 'react';
import ReactDOM from 'react-dom';
import { useAsync, useElement, useImmer, useIsomorphicLayoutEffect, useLockScroll } from '@react-devui/hooks';
import { CloseOutlined, LeftOutlined, RightOutlined, RotateRightOutlined, ZoomInOutlined, ZoomOutOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useDValue, useMaxIndex } from '../../hooks';
import { registerComponentMate, TTANSITION_DURING_BASE } from '../../utils';
import { DMask } from '../_mask';
import { DTransition } from '../_transition';
import { DButton } from '../button';
import { DInput } from '../input';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DImage.Preview' });
export function DImagePreview(props) {
    var _a, _b, _c;
    const _d = useComponentConfig(COMPONENT_NAME, props), { dList, dActive, dVisible, dZIndex, dMask = true, dMaskClosable = true, dEscClosable = true, onActiveChange, onVisibleChange, afterVisibleChange } = _d, restProps = __rest(_d, ["dList", "dActive", "dVisible", "dZIndex", "dMask", "dMaskClosable", "dEscClosable", "onActiveChange", "onVisibleChange", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const previewRef = useRef(null);
    const imgRef = useRef(null);
    //#endregion
    const asyncCapture = useAsync();
    const [activeIndex, changeActiveIndex] = useDValue(0, dActive, onActiveChange);
    const activeSrc = dList[activeIndex].src;
    const [offset, setOffset] = useState(3);
    useIsomorphicLayoutEffect(() => {
        const handleResize = () => {
            setOffset(~~((window.innerWidth - 108) / 120));
        };
        handleResize();
        window.addEventListener('resize', handleResize);
        return () => {
            window.removeEventListener('resize', handleResize);
        };
    });
    let startIndex = Math.max(activeIndex - offset, 0);
    const endIndex = Math.min(startIndex + offset * 2, dList.length - 1);
    startIndex = Math.max(endIndex - offset * 2, 0);
    const [isDragging, setIsDragging] = useState(false);
    const [position, setPosition] = useImmer(new Map());
    const activePosition = (_a = position.get(activeSrc)) !== null && _a !== void 0 ? _a : { top: 0, left: 0 };
    const [rotate, setRotate] = useImmer(new Map());
    const activeRotate = (_b = rotate.get(activeSrc)) !== null && _b !== void 0 ? _b : 0;
    const [scale, setScale] = useImmer(new Map());
    const activeScale = (_c = scale.get(activeSrc)) !== null && _c !== void 0 ? _c : 1;
    const [visible, changeVisible] = useDValue(false, dVisible, onVisibleChange);
    const maxZIndex = useMaxIndex(visible);
    const zIndex = (() => {
        if (!isUndefined(dZIndex)) {
            return dZIndex;
        }
        return maxZIndex;
    })();
    const containerEl = useElement(() => {
        let el = document.getElementById(`${dPrefix}image-preview-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${dPrefix}image-preview-root`;
            document.body.appendChild(el);
        }
        return el;
    });
    useLockScroll(visible);
    const prevActiveEl = useRef(null);
    useEffect(() => {
        if (visible) {
            prevActiveEl.current = document.activeElement;
            if (previewRef.current) {
                previewRef.current.focus({ preventScroll: true });
            }
        }
        else if (prevActiveEl.current) {
            prevActiveEl.current.focus({ preventScroll: true });
        }
    }, [visible]);
    useEffect(() => {
        const [asyncGroup, asyncId] = asyncCapture.createGroup();
        if (isDragging && imgRef.current) {
            let initMove;
            let currentMove;
            let initScale;
            let currentScale;
            const handleMove = () => {
                if (initMove && currentMove) {
                    const movementX = currentMove.x - initMove.x;
                    const movementY = currentMove.y - initMove.y;
                    setPosition((draft) => {
                        var _a;
                        const oldPosition = (_a = draft.get(activeSrc)) !== null && _a !== void 0 ? _a : { top: 0, left: 0 };
                        draft.set(activeSrc, {
                            top: oldPosition.top + movementY,
                            left: oldPosition.left + movementX,
                        });
                    });
                    initMove = currentMove;
                    currentMove = undefined;
                }
                if (initScale && currentScale) {
                    const initLength = Math.sqrt(Math.pow(initScale.x0 - initScale.x1, 2) + Math.pow(initScale.y0 - initScale.y1, 2));
                    const currentLength = Math.sqrt(Math.pow(currentScale.x0 - currentScale.x1, 2) + Math.pow(currentScale.y0 - currentScale.y1, 2));
                    setScale((draft) => {
                        var _a;
                        const oldScale = (_a = draft.get(activeSrc)) !== null && _a !== void 0 ? _a : 1;
                        draft.set(activeSrc, Math.max(oldScale + (currentLength - initLength) / 100, 1));
                    });
                    initScale = currentScale;
                    currentScale = undefined;
                }
            };
            asyncGroup.fromEvent(window, 'touchmove', { passive: false }).subscribe({
                next: (e) => {
                    e.preventDefault();
                    if (e.touches.length === 2) {
                        initMove = currentMove = undefined;
                        const newScale = {
                            x0: e.touches[0].clientX,
                            y0: e.touches[0].clientY,
                            x1: e.touches[1].clientX,
                            y1: e.touches[1].clientY,
                        };
                        if (isUndefined(initScale)) {
                            initScale = newScale;
                        }
                        else {
                            currentScale = newScale;
                        }
                    }
                    else {
                        initScale = currentScale = undefined;
                        const newMove = {
                            x: e.touches[0].clientX,
                            y: e.touches[0].clientY,
                        };
                        if (isUndefined(initMove)) {
                            initMove = newMove;
                        }
                        else {
                            currentMove = newMove;
                        }
                    }
                    handleMove();
                },
            });
            asyncGroup.fromEvent(window, 'mousemove').subscribe({
                next: (e) => {
                    e.preventDefault();
                    const newMove = {
                        x: e.clientX,
                        y: e.clientY,
                    };
                    if (isUndefined(initMove)) {
                        initMove = newMove;
                    }
                    else {
                        currentMove = newMove;
                    }
                    handleMove();
                },
            });
        }
        return () => {
            asyncCapture.deleteGroup(asyncId);
        };
    }, [activeSrc, asyncCapture, isDragging, setPosition, setScale]);
    useEffect(() => {
        const [asyncGroup, asyncId] = asyncCapture.createGroup();
        if (isDragging) {
            asyncGroup.fromEvent(window, 'mouseup').subscribe({
                next: (e) => {
                    e.preventDefault();
                    setIsDragging(false);
                },
            });
        }
        return () => {
            asyncCapture.deleteGroup(asyncId);
        };
    }, [asyncCapture, isDragging]);
    return (containerEl &&
        ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE, afterEnter: () => {
                afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
            }, afterLeave: () => {
                afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
            } }, { children: (state) => {
                let transitionStyle = {};
                switch (state) {
                    case 'enter':
                        transitionStyle = { transform: 'scale(0.3)', opacity: 0 };
                        break;
                    case 'entering':
                        transitionStyle = {
                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                        };
                        break;
                    case 'leaving':
                        transitionStyle = {
                            transform: 'scale(0.3)',
                            opacity: 0,
                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                        };
                        break;
                    default:
                        break;
                }
                return (_jsxs("div", Object.assign({}, restProps, { ref: previewRef, className: getClassName(restProps.className, `${dPrefix}image-preview`), style: Object.assign(Object.assign(Object.assign({}, restProps.style), transitionStyle), { display: state === 'leaved' ? 'none' : undefined, zIndex }), tabIndex: -1, onKeyDown: (e) => {
                        if (dEscClosable && e.code === 'Escape') {
                            changeVisible(false);
                        }
                    } }, { children: [_jsx("button", Object.assign({ className: getClassName(`${dPrefix}image-preview__navigation-button`, `${dPrefix}image-preview__navigation-button--prev`), onClick: () => {
                                changeActiveIndex((draft) => {
                                    return draft === 0 ? dList.length - 1 : draft - 1;
                                });
                            } }, { children: _jsx(LeftOutlined, {}) })), _jsx("button", Object.assign({ className: getClassName(`${dPrefix}image-preview__navigation-button`, `${dPrefix}image-preview__navigation-button--next`), onClick: () => {
                                changeActiveIndex((draft) => {
                                    return draft === dList.length - 1 ? 0 : draft + 1;
                                });
                            } }, { children: _jsx(RightOutlined, {}) })), _jsxs("ul", Object.assign({ className: `${dPrefix}image-preview__toolbar` }, { children: [_jsxs("li", Object.assign({ className: `${dPrefix}image-preview__toolbar-page` }, { children: [_jsx(DInput, { className: `${dPrefix}image-preview__toolbar-page-input`, dModel: (activeIndex + 1).toString(), dType: "number", dSize: "smaller", dMin: 1, dMax: dList.length, dInteger: true, onModelChange: (val) => {
                                                if (val) {
                                                    changeActiveIndex(Number(val) - 1);
                                                }
                                            } }), _jsx("span", { children: "/" }), _jsx("span", { children: dList.length })] })), _jsx("li", Object.assign({ className: `${dPrefix}image-preview__toolbar-rotate` }, { children: _jsx(DButton, { onClick: () => {
                                            setRotate((draft) => {
                                                var _a;
                                                const oldRotate = (_a = draft.get(activeSrc)) !== null && _a !== void 0 ? _a : 0;
                                                draft.set(activeSrc, oldRotate + 90);
                                            });
                                        }, dType: "text", dIcon: _jsx(RotateRightOutlined, {}) }) })), _jsx("li", Object.assign({ className: `${dPrefix}image-preview__toolbar-zoom-out` }, { children: _jsx(DButton, { onClick: () => {
                                            setScale((draft) => {
                                                var _a;
                                                const oldScale = (_a = draft.get(activeSrc)) !== null && _a !== void 0 ? _a : 1;
                                                draft.set(activeSrc, Math.max(oldScale / 1.3, 1));
                                            });
                                        }, dType: "text", dIcon: _jsx(ZoomOutOutlined, {}) }) })), _jsx("li", Object.assign({ className: `${dPrefix}image-preview__toolbar-zoom` }, { children: _jsx(DInput, { className: `${dPrefix}image-preview__toolbar-zoom-input`, dModel: Math.round(activeScale * 100).toString(), dType: "number", dSize: "smaller", dMin: 100, dStep: 10, dInteger: true, onModelChange: (val) => {
                                            if (val) {
                                                setScale((draft) => {
                                                    draft.set(activeSrc, Number(val) / 100);
                                                });
                                            }
                                        } }) })), _jsx("li", Object.assign({ className: `${dPrefix}image-preview__toolbar-zoom-in` }, { children: _jsx(DButton, { onClick: () => {
                                            setScale((draft) => {
                                                var _a;
                                                const oldScale = (_a = draft.get(activeSrc)) !== null && _a !== void 0 ? _a : 1;
                                                draft.set(activeSrc, oldScale * 1.3);
                                            });
                                        }, dType: "text", dIcon: _jsx(ZoomInOutlined, {}) }) })), _jsx("li", Object.assign({ className: `${dPrefix}image-preview__toolbar-close` }, { children: _jsx(DButton, { onClick: () => {
                                            changeVisible(false);
                                        }, dType: "text", dIcon: _jsx(CloseOutlined, {}) }) }))] })), 
                        // eslint-disable-next-line jsx-a11y/alt-text
                        _jsx("img", Object.assign({}, dList[activeIndex], { ref: imgRef, className: `${dPrefix}image-preview__img`, style: {
                                transform: `translate(${activePosition.left}px, ${activePosition.top}px) rotate(${activeRotate}deg) scale(${activeScale})`,
                            }, width: undefined, height: undefined, tabIndex: -1, onMouseDown: (e) => {
                                if (e.button === 0) {
                                    e.preventDefault();
                                    e.currentTarget.focus({ preventScroll: true });
                                    setIsDragging(true);
                                }
                            }, onMouseUp: (e) => {
                                if (e.button === 0) {
                                    e.preventDefault();
                                }
                            }, onTouchStart: (e) => {
                                e.currentTarget.focus({ preventScroll: true });
                                setIsDragging(true);
                            }, onTouchEnd: () => {
                                setIsDragging(false);
                            }, onWheel: (e) => {
                                setScale((draft) => {
                                    var _a;
                                    const oldScale = (_a = draft.get(activeSrc)) !== null && _a !== void 0 ? _a : 1;
                                    draft.set(activeSrc, e.deltaY < 0 ? oldScale + 0.1 : Math.max(oldScale - 0.1, 1));
                                });
                            } })), _jsx("ul", Object.assign({ className: `${dPrefix}image-preview__thumbnail-list` }, { children: dList.map((imgProps, index) => index >= startIndex &&
                                index <= endIndex && (_jsx("li", Object.assign({ className: getClassName(`${dPrefix}image-preview__thumbnail`, {
                                    'is-active': activeIndex === index,
                                }), onClick: () => {
                                    changeActiveIndex(index);
                                } }, { children: 
                                // eslint-disable-next-line jsx-a11y/alt-text
                                _jsx("img", Object.assign({}, imgProps, { className: `${dPrefix}image-preview__thumbnail-img`, style: undefined, width: undefined, height: undefined })) }), index))) })), dMask && (_jsx(DMask, { dVisible: true, onClose: () => {
                                if (dMaskClosable) {
                                    changeVisible(false);
                                }
                            } }))] })));
            } })), containerEl));
}
//# sourceMappingURL=ImagePreview.js.map