var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, jsxs as _jsxs, Fragment as _Fragment } from "react/jsx-runtime";
import { isNumber, isString, isUndefined } from 'lodash';
import React, { useEffect, useId, useRef } from 'react';
import ReactDOM from 'react-dom';
import { useAsync, useElement, useLockScroll } from '@react-devui/hooks';
import { CheckCircleOutlined, CloseCircleOutlined, ExclamationCircleOutlined, WarningOutlined } from '@react-devui/icons';
import { checkNodeExist, getClassName } from '@react-devui/utils';
import { usePrefixConfig, useComponentConfig, useMaxIndex, useDValue } from '../../hooks';
import { registerComponentMate, handleModalKeyDown, TTANSITION_DURING_BASE } from '../../utils';
import { DMask } from '../_mask';
import { DTransition } from '../_transition';
import { DModalFooter } from './ModalFooter';
import { DModalHeader } from './ModalHeader';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DModal' });
export const DModal = (props) => {
    const _a = useComponentConfig(COMPONENT_NAME, props), { children, dVisible, dWidth = 520, dTop = 100, dZIndex, dMask = true, dMaskClosable = true, dEscClosable = true, dType, dHeader, dFooter, onVisibleChange, afterVisibleChange } = _a, restProps = __rest(_a, ["children", "dVisible", "dWidth", "dTop", "dZIndex", "dMask", "dMaskClosable", "dEscClosable", "dType", "dHeader", "dFooter", "onVisibleChange", "afterVisibleChange"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const modalRef = useRef(null);
    const modalContentRef = useRef(null);
    //#endregion
    const dataRef = useRef({ x: 0, y: 0 });
    const asyncCapture = useAsync();
    const uniqueId = useId();
    const titleId = `${dPrefix}modal-title-${uniqueId}`;
    const bodyId = `${dPrefix}modal-content-${uniqueId}`;
    const topStyle = dTop + (isNumber(dTop) ? 'px' : '');
    const [visible, changeVisible] = useDValue(false, dVisible, onVisibleChange);
    const maxZIndex = useMaxIndex(visible);
    const zIndex = (() => {
        if (!isUndefined(dZIndex)) {
            return dZIndex;
        }
        return maxZIndex;
    })();
    const containerEl = useElement(() => {
        let el = document.getElementById(`${dPrefix}modal-root`);
        if (!el) {
            el = document.createElement('div');
            el.id = `${dPrefix}modal-root`;
            document.body.appendChild(el);
        }
        return el;
    });
    useLockScroll(visible);
    const prevActiveEl = useRef(null);
    useEffect(() => {
        if (visible) {
            prevActiveEl.current = document.activeElement;
            if (modalRef.current) {
                modalRef.current.focus({ preventScroll: true });
            }
        }
        else if (prevActiveEl.current) {
            prevActiveEl.current.focus({ preventScroll: true });
        }
    }, [visible]);
    useEffect(() => {
        const [asyncGroup, asyncId] = asyncCapture.createGroup();
        asyncGroup.fromEvent(window, 'click', { capture: true }).subscribe({
            next: (e) => {
                var _a, _b;
                dataRef.current.x = e.clientX;
                dataRef.current.y = e.clientY;
                (_b = (_a = dataRef.current).clearTid) === null || _b === void 0 ? void 0 : _b.call(_a);
                dataRef.current.clearTid = asyncGroup.setTimeout(() => {
                    dataRef.current.clearTid = undefined;
                }, 20);
            },
        });
        return () => {
            asyncCapture.deleteGroup(asyncId);
        };
    }, [asyncCapture]);
    const headerNode = (() => {
        if (dHeader) {
            const node = isString(dHeader) ? _jsx(DModalHeader, { children: dHeader }) : dHeader;
            return React.cloneElement(node, Object.assign(Object.assign({}, node.props), { __id: titleId, __onClose: () => {
                    changeVisible(false);
                } }));
        }
    })();
    return (containerEl &&
        ReactDOM.createPortal(_jsx(DTransition, Object.assign({ dIn: visible, dDuring: TTANSITION_DURING_BASE, onEnterRendered: () => {
                if (isUndefined(dataRef.current.clearTid)) {
                    dataRef.current.transformOrigin = undefined;
                }
                else if (modalContentRef.current) {
                    const left = `${(window.innerWidth - modalContentRef.current.clientWidth) / 2}px`;
                    const top = dTop === 'center' ? `${(window.innerHeight - modalContentRef.current.clientHeight) / 2}px` : topStyle;
                    dataRef.current.transformOrigin = `calc(${dataRef.current.x}px - ${left}) calc(${dataRef.current.y}px - ${top})`;
                }
            }, afterEnter: () => {
                afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(true);
            }, afterLeave: () => {
                afterVisibleChange === null || afterVisibleChange === void 0 ? void 0 : afterVisibleChange(false);
            } }, { children: (state) => {
                var _a, _b, _c, _d;
                let transitionStyle = {};
                switch (state) {
                    case 'enter':
                        transitionStyle = { transform: 'scale(0.3)', opacity: 0 };
                        break;
                    case 'entering':
                        transitionStyle = {
                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-out`).join(', '),
                            transformOrigin: dataRef.current.transformOrigin,
                        };
                        break;
                    case 'leaving':
                        transitionStyle = {
                            transform: 'scale(0.3)',
                            opacity: 0,
                            transition: ['transform', 'opacity'].map((attr) => `${attr} ${TTANSITION_DURING_BASE}ms ease-in`).join(', '),
                            transformOrigin: dataRef.current.transformOrigin,
                        };
                        break;
                    default:
                        break;
                }
                return (_jsxs("div", Object.assign({}, restProps, { ref: modalRef, className: getClassName(restProps.className, `${dPrefix}modal`, {
                        [`${dPrefix}modal--center`]: dTop === 'center',
                        [`${dPrefix}modal--type`]: dType,
                    }), style: Object.assign(Object.assign({}, restProps.style), { display: state === 'leaved' ? 'none' : undefined, zIndex }), tabIndex: -1, role: (_a = restProps.role) !== null && _a !== void 0 ? _a : 'dialog', "aria-modal": (_b = restProps['aria-modal']) !== null && _b !== void 0 ? _b : 'true', "aria-labelledby": (_c = restProps['aria-labelledby']) !== null && _c !== void 0 ? _c : (headerNode ? titleId : undefined), "aria-describedby": (_d = restProps['aria-describedby']) !== null && _d !== void 0 ? _d : bodyId, onKeyDown: (e) => {
                        var _a;
                        (_a = restProps.onKeyDown) === null || _a === void 0 ? void 0 : _a.call(restProps, e);
                        if (dEscClosable && e.code === 'Escape') {
                            changeVisible(false);
                        }
                        handleModalKeyDown(e);
                    } }, { children: [dMask && (_jsx(DMask, { dVisible: visible, onClose: () => {
                                if (dMaskClosable) {
                                    changeVisible(false);
                                }
                            } })), _jsxs("div", Object.assign({ ref: modalContentRef, className: `${dPrefix}modal__content`, style: Object.assign(Object.assign({}, transitionStyle), { width: dWidth, top: dTop === 'center' ? undefined : dTop, maxHeight: dTop === 'center' ? undefined : `calc(100% - ${topStyle} - 20px)` }) }, { children: [headerNode, _jsx("div", Object.assign({ id: bodyId, className: `${dPrefix}modal__body` }, { children: dType ? (_jsxs(_Fragment, { children: [_jsx("div", Object.assign({ className: `${dPrefix}modal__icon` }, { children: checkNodeExist(dType.icon) ? (dType.icon) : dType.type === 'success' ? (_jsx(CheckCircleOutlined, { dTheme: "success" })) : dType.type === 'warning' ? (_jsx(WarningOutlined, { dTheme: "warning" })) : dType.type === 'error' ? (_jsx(CloseCircleOutlined, { dTheme: "danger" })) : (_jsx(ExclamationCircleOutlined, { dTheme: "primary" })) })), _jsxs("div", Object.assign({ className: `${dPrefix}modal__type-wrapper` }, { children: [checkNodeExist(dType.title) && _jsx("div", Object.assign({ className: `${dPrefix}modal__title` }, { children: dType.title })), checkNodeExist(dType.description) && _jsx("div", Object.assign({ className: `${dPrefix}modal__description` }, { children: dType.description }))] }))] })) : (children) })), dFooter &&
                                    React.cloneElement(dFooter, Object.assign(Object.assign({}, dFooter.props), { __onClose: () => {
                                            changeVisible(false);
                                        } }))] }))] })));
            } })), containerEl));
};
DModal.Header = DModalHeader;
DModal.Footer = DModalFooter;
//# sourceMappingURL=Modal.js.map