var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { jsx as _jsx, Fragment as _Fragment, jsxs as _jsxs } from "react/jsx-runtime";
import { isUndefined } from 'lodash';
import React, { useRef } from 'react';
import { ClockCircleOutlined } from '@react-devui/icons';
import { getClassName } from '@react-devui/utils';
import { useComponentConfig, usePrefixConfig, useTranslation } from '../../hooks';
import { registerComponentMate } from '../../utils';
import { DButton } from '../button';
import { DBuilder } from '../date-picker/Builder';
import { getCols, orderTime } from '../date-picker/utils';
import { DPanel } from './Panel';
const { COMPONENT_NAME } = registerComponentMate({ COMPONENT_NAME: 'DTimePicker' });
function TimePicker(props, ref) {
    const _a = useComponentConfig(COMPONENT_NAME, props), { dFormat, dPlaceholder, dOrder = 'ascend', d12Hour = false, dRange = false, dConfigTime, dPopupClassName } = _a, restProps = __rest(_a, ["dFormat", "dPlaceholder", "dOrder", "d12Hour", "dRange", "dConfigTime", "dPopupClassName"]);
    //#region Context
    const dPrefix = usePrefixConfig();
    //#endregion
    //#region Ref
    const dTPPRef = useRef(null);
    //#endregion
    const [t] = useTranslation();
    const format = isUndefined(dFormat) ? (d12Hour ? 'hh:mm:ss A' : 'HH:mm:ss') : dFormat;
    const [placeholderLeft = t('TimePicker', dRange ? 'Start time' : 'Select time'), placeholderRight = t('TimePicker', 'End time')] = (dRange ? dPlaceholder !== null && dPlaceholder !== void 0 ? dPlaceholder : [] : [dPlaceholder]);
    return (_jsx(DBuilder, Object.assign({}, restProps, { ref: ref, dClassNamePrefix: "time-picker", dFormat: format, dSuffix: _jsx(ClockCircleOutlined, {}), dPlaceholder: [placeholderLeft, placeholderRight], dOrder: (date) => orderTime(date, dOrder), dRange: dRange, dPopupClassName: getClassName(dPopupClassName, `${dPrefix}time-picker__popup`), onUpdatePanel: (date) => {
            var _a;
            (_a = dTPPRef.current) === null || _a === void 0 ? void 0 : _a.updateView(date);
        } }, { children: ({ pbDate, pbCurrentDate, pbPosition, changeValue }) => (_jsxs(_Fragment, { children: [_jsx(DPanel, { ref: dTPPRef, dTime: pbDate, dCols: getCols(format), d12Hour: d12Hour, dConfigTime: dConfigTime ? (...args) => dConfigTime(...args, pbPosition, pbCurrentDate) : undefined, onTimeChange: changeValue }), _jsx("div", Object.assign({ className: `${dPrefix}time-picker__footer` }, { children: _jsx(DButton, Object.assign({ onClick: () => {
                            var _a;
                            const now = new Date();
                            changeValue(now);
                            (_a = dTPPRef.current) === null || _a === void 0 ? void 0 : _a.updateView(now);
                        }, dType: "link" }, { children: t('TimePicker', 'Now') })) }))] })) })));
}
export const DTimePicker = React.forwardRef(TimePicker);
//# sourceMappingURL=TimePicker.js.map