import type { DId } from '../../utils';
import type { DComboboxKeyboardSupportKey } from '../_keyboard-support';
import type { DTreeItem } from './Tree';
import type { AbstractTreeNode } from './node';
import type { Subject } from 'rxjs';
import React from 'react';
import { TREE_NODE_KEY } from './utils';
export declare type DSearchItem<V extends DId, T> = DTreeItem<V> & {
    [TREE_NODE_KEY]: AbstractTreeNode<V, T>;
};
interface DSearchPanelProps<V extends DId, T extends DTreeItem<V>> extends Omit<React.HTMLAttributes<HTMLElement>, 'children'> {
    dGetItemId: (value: V) => string;
    dList: DSearchItem<V, T>[];
    dFocusItem: DSearchItem<V, T> | undefined;
    dCustomItem?: (item: T) => React.ReactNode;
    dMultiple: boolean;
    dOnlyLeafSelectable?: boolean;
    dFocusVisible: boolean;
    onFocusChange: (item: DSearchItem<V, T>) => void;
    onClickItem: (item: DSearchItem<V, T>) => void;
    onKeyDown$: Subject<DComboboxKeyboardSupportKey | 'click'>;
}
export declare function DSearchPanel<V extends DId, T extends DTreeItem<V>>(props: DSearchPanelProps<V, T>): JSX.Element | null;
export {};
